// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.io.*;

class AlgoReader{
    public static Algorithm getAlgoFromFile(String filename){
        Algorithm algo=new Algorithm();
        File inFile = new File(filename);
        String line;
        Rule r;
        try{
            BufferedReader reader = new BufferedReader(new FileReader(inFile));
            // Read the default State
            do{
                line=reader.readLine();
                if (line.compareTo("=")!=0) algo.addDefState(line);
            }while (line.compareTo("=")!=0);
            // Read the initial distinguished State
            do{
                line=reader.readLine();
                if (line.compareTo("=")!=0) algo.addDistState(line);
            }while (line.compareTo("=")!=0);
            // Reads the rules
            do{
                r = new Rule();
                r.setPreconds(reader.readLine());
                r.setActions(reader.readLine());
                algo.addRule(r);
                line=reader.readLine();
            }while (line.compareTo("=")!=0);
            reader.close();
        }catch (Exception e){
            System.out.println("erreur de lecture du fichier");
        }
        return algo;
    }
}
