// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.io.*;
import java.util.*;

class AlgoWriter{
    public static void putAlgoToFile(Algorithm algo, String filename){
        File toFile = new File(filename);
        try{
            BufferedWriter writer = new BufferedWriter(new FileWriter(toFile));
            // Defaults States
            Hashtable hdef = algo.getDefState();
            for (Enumeration e = hdef.keys(); e.hasMoreElements() ;){
                String key=(String)e.nextElement();
                writer.write(key + "," + (String)hdef.get(key) + "\n");
            }
            writer.write("=\n");
            // Distinguished States
            Hashtable hdist = algo.getDistState();
            for (Enumeration e = hdist.keys(); e.hasMoreElements() ;){
                String key=(String)e.nextElement();
                writer.write(key + "," + (String)hdist.get(key) + "\n");
            }
            writer.write("=\n");
            // Rules
            Vector rules = algo.getRules();
            for (int i=0; i<rules.size(); i++){
                if (i>0)
                    writer.write("_\n");
                Rule r=(Rule)rules.elementAt(i);
                writer.write(r.getPreconds().toString()+"\n"+r.getActions().toString() + "\n");
            }
            writer.write("=\n");
            writer.close();
        }catch (Exception e){
            System.out.println("erreur de lecture du fichier");
        }
    }
}
