// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.util.*;

public class Gui extends JFrame{
    JTopology panel;
    Command cmd;
    Editor editor;

    public Gui(Topology t, int delay, Algorithm algo){
        super("simuDAGRS");
	panel = new JTopology(t, delay);
        panel.setPreferredSize(new Dimension(600,500));
        editor=new Editor();
        editor.setAlgorithm(algo);
        panel.setEditor(editor);
        cmd=new Command(t,algo,editor);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        Container c = getContentPane();
        c.setLayout(new FlowLayout());
        c.add(cmd);
        c.add(panel);
        c.add(editor);
	c.setLocation(100,100);
	this.setSize(930, 600);
	this.setVisible(true);
    }
}
