// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import javax.swing.*;
import java.awt.event.*;

public class JVertex extends JButton implements MouseListener, MouseMotionListener{
    JTopology parent;
    Vertex v;
    final static int rad=10;

    public JVertex(JTopology parent, Vertex v){
	super(new ImageIcon("./circle.png"));
	this.v=v;
	this.setToolTipText(v.toString());
	this.parent=parent;
	this.setBounds(v.getX()-10,v.getY()-10,20,20);
	this.addMouseListener(this);
	this.addMouseMotionListener(this);
    }
    public Vertex getVertex(){
	return v;
    }
    public void mouseClicked(MouseEvent e){
    }
    public void mouseEntered(MouseEvent e){
    }
    public void mouseExited(MouseEvent e){
    }
    public void mousePressed(MouseEvent e) {
	if (e.getButton()==e.BUTTON3){
	    parent.removeJVertex(this);
	}else if (e.getButton()==e.BUTTON2){
            parent.selectVertex(this.v);
        }
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseMoved(MouseEvent e){
    }
    public void mouseDragged(MouseEvent e){
	move(v.getX() + e.getX(), v.getY() + e.getY());
    }
    public void move(int x, int y){
	v.move(x-rad, y-rad); // Deplace le vrai noeud.
	move(); // Deplace le composant
    }
    public void move(){
	setBounds(v.getX()-rad, v.getY()-rad, rad*2, rad*2);
	parent.updateUI();
    }	
}
