// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.util.*;

public class Neighbor{
    private Vertex vertex; // the neighbor
    private int dist; // distance
    private int variation; // variation of the distance
    private String label; // edge label
    private Hashtable labels; // edge labels
    private String state;
    private int updated;

    public Neighbor(Vertex v, String label, int dist){
        this.vertex=v;
        this.dist=dist;
        this.variation=100;
        this.label=label;
        this.labels=new Hashtable();
        this.labels.put("main", label);
        this.state="on";
    }
    public Vertex getVertex(){
        return vertex;
    }
    public int getDist(){
        return dist;
    }
    public int getVariation(){
        return variation;
    }
    public String getLinkLabel(){
        return (String)labels.get("main");
    }
    public String getLinkLabel(String key){
        return (String)labels.get(key);
    }
    public String getLabelsToString(){
        String s="";
        for (Enumeration e=labels.keys();e.hasMoreElements();){
            s=s+(String) labels.get(e.nextElement());
            if (e.hasMoreElements())
                s=s+" ";
        }
        return s;
    }
    public String getLinkState(){
        return this.state;
    }
    public int getUpdated(){
        return this.updated;
    }
    public void setLinkLabel(String s){
        this.labels.put("main",s);
    }
    public void setLinkState(String state){
        this.state = state;
    }
    public void setDist(int d){
        this.variation = Math.abs(dist - d);
        this.dist = d;
    }
    public void setUpdated(int update){
        this.updated=update;
    }
}
