// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import java.util.*;

public class Recorder{
    
    private Topology t;
    private EvolvingGraph eg;
    private Integer time;
    
    public Recorder(Topology t){
        this.t=t;
        eg=new EvolvingGraph();
        this.time=new Integer(1);
    }
    public void snapEvolveStep(){
        Vector vertices=t.getVertices();
        for (int i=0; i<vertices.size(); i++){
            Vertex v=(Vertex)vertices.elementAt(i);
            eg.addNode(v.toString(), v.getX(), v.getY());
            for (int j=0; j<v.neighbors.size(); j++){
                Vertex n=((Neighbor)v.neighbors.elementAt(j)).getVertex();
                eg.addEdge(v.toString(), n.toString(), time);
            }
        }
        time=new Integer(time.intValue()+1);
    }
    public String toString(){
        return eg.toString();
    }
}
