// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.util.*;

public class Rule {

    private TreeNode preconds;
    private TreeNode actions;

    public Rule(){
        super();
    }

    public void setPreconds(String preconds){
        this.preconds = new TreeNode(preconds);
    }
    public void setActions(String actions){
        this.actions = new TreeNode(actions);
    }
    public TreeNode getPreconds(){
        return this.preconds;
    }
    public TreeNode getActions(){
        return this.actions;
    }
    public boolean execute(Vertex v1, Neighbor n2){
        boolean exec;
        if (exec=preconds.verify(v1,n2))
            actions.execute(v1,n2);
        return exec;
    }
}
