// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.util.*;

public class TopologyRandomizer extends Thread{
    private int delay=10;
    private Topology t;
    private Random r;
    private int xmax=500, ymax=500;

    TopologyRandomizer(Topology t){
	super();
	this.t = t;
	this.r = new Random();
    }
    TopologyRandomizer(Topology t, int delay){
	this(t);
	this.delay = delay;
    }
    TopologyRandomizer(Topology t, int xmax, int ymax){
	this(t);
	this.xmax = xmax;
	this.ymax = ymax;
    }
    TopologyRandomizer(Topology t, int delay, int xmax, int ymax){
	this(t, xmax, ymax);
	this.delay = delay;
    }

    public void run(){
	int tendancex=2;
	int tendancey=2;
	while (true){
	    Vector vec=t.getVertices();
	    int choix=r.nextInt(600);

	    if (choix==1 && vec.size()>1)
		vec.remove(vec.elementAt(r.nextInt(vec.size())));
	    else if ((choix==2) && vec.size()<100)
            vec.add(t.addVertex(r.nextInt(xmax), r.nextInt(ymax)));
	    else if (choix==101) tendancex=3;
	    else if (choix==102) tendancey=3;
	    else if (choix==103) tendancex=2;
	    else if (choix==104) tendancey=2;
	    else if (vec.size()>1){
		Vertex v=((Vertex)(vec.elementAt(r.nextInt(vec.size()))));
		v.move(Math.abs(v.getX()+r.nextInt(6)-tendancex)%xmax,Math.abs(v.getY()+r.nextInt(6)-tendancey)%ymax);
	    }
	    try{
		Thread.sleep(delay);
	    }catch(Exception e){}
	}
    }
}
