// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import java.util.*;
import java.io.*;
import java.awt.Point;

public class TopologyToFiles{
    public static final int PHYSIC=0, LOGIC=1, EVOLVING=2;
    public static void toFiles(Topology t, String basename, int mode){
	try{
            FileWriter fil = new FileWriter(basename+".txt");
            PrintWriter skr = new PrintWriter(new BufferedWriter(fil)); 
            if (mode==PHYSIC){
                t.exportLogic=false;
                skr.print(t);
            }else if (mode==LOGIC){
                t.exportLogic=true;
                skr.print(t);
            }else if (mode==EVOLVING){
                skr.print(t.getEvolve());
            }
            skr.close();
            GraphToEPS.main(basename+".txt", basename+".eps", 0);
            if (mode==LOGIC)
                GraphToEPS.main(basename+".txt", basename+"-col.eps", 1);
	}catch(Exception e){e.printStackTrace();}
    }
}
