// This file is part of Dagrs.

// Dagrs is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// Dagrs is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Dagrs; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


public class TreeNode{
    public String value;
    public TreeNode left;
    public TreeNode right;
    public Condition cond;

    public TreeNode(String s){
        cond=null;
        this.fillTree(s);
    }
    private boolean isLeaf(String s){
        if (s.indexOf("&")==-1 && s.indexOf("|")==-1)
            return true;
        return false;
    }
    public void fillTree(String s){
        s=removeSpacesAndBraces(s);
        if (isLeaf(s)){
            this.value=s;
            this.cond=new Condition(s);
            this.left=null;
            this.right=null;
        }else{
            int b=0;
            while (s.charAt(b) != '&' && s.charAt(b)!='|' && s.charAt(b) != '(')
                b++;
            if (s.charAt(b)=='('){
                int c=1;
                while (c!=0){
                    b++;
                    if (s.charAt(b)=='(')
                        c++;
                    if (s.charAt(b)==')')
                        c--;
                }
                while (s.charAt(b) != '&' && s.charAt(b)!='|' )
                    b++;
            }
            this.left=new TreeNode(s.substring(0,b));
            this.value=new String(s.substring(b,b+1));
            this.right=new TreeNode(s.substring(b+1, s.length()));
        }
    }
    public boolean verify(Vertex v1, Neighbor n2){
        if (cond == null){
            if (value.compareTo("&")==0)
                return (left.verify(v1, n2) && right.verify(v1, n2));
            else
                return (left.verify(v1, n2) || right.verify(v1, n2));
        }else
            return cond.verify(v1,n2);
    }
    public void execute(Vertex v1, Neighbor n2){
        if (cond == null){
            left.execute(v1, n2);
            right.execute(v1, n2);
        }else
            cond.execute(v1,n2);
    }
    // Methodes de nettoyage
    public static String removeSpacesAndBraces(String s){
        String s2=new String(s);
        do{
            s=new String(s2);
            s2=s2.trim();
            s2=TreeNode.removeBraces(s2);
        }while(s2.compareTo(s)!=0);
        return s2;
    }
    private static String removeBraces(String s){
        int count;
        int b=0;
        if (s.charAt(0)=='('){
            count=1;
            while (count != 0){
                b++;
                if (s.charAt(b)=='(')
                    count++;
                if (s.charAt(b)==')')
                    count--;       
            }
            if (b==s.length()-1)
                return s.substring(1,s.length()-1);
        }
        return s;
    }
    // Affichage pour le debuggage
    public String toString(){
        if (this.left==null)
            return cond.toString();
        else
            return('('+left.toString()+" "+value+" "+right.toString()+')');
    }
}
