import java.util.*;

public class Edge{
    private Node n1;
    private Node n2;
    private Vector times;

    public Edge(Node n1, Node n2, Vector times){
        this.n1=n1;
        this.n2=n2;
        this.times=times;
    }

    public Node getOtherEndpoint(Node n){
        return (n==n1)?n2:n1;
    }
    
    public Vector getEndpoints(){
        Vector v=new Vector();
        v.add(n1);
        v.add(n2);
        return v;
    }

    public Vector getTimes(){
        Vector ret=new Vector();
        for (int j=0; j<times.size(); j++){
            Integer t=(Integer)times.elementAt(j);
            ret.add(t);
        }
        return ret;
    }

    public Edge doTimeCut(Integer beg, Integer end){
        Vector union=new Vector();
        for (int j=0; j<times.size(); j++){
            Integer t=(Integer)times.elementAt(j);
            if (t>=beg && t<end)
                union.add(t);
        }
        times=union;
        return (times.size()>0)?this:null;
    }

    public String timesAsString(){
        String stimes=" ";
        for (int i=0; i<times.size()-1; i++){
            Integer t=(Integer)times.elementAt(i);
            char last=stimes.charAt(stimes.length()-1);
            if (last==' '){
                stimes=stimes+t.toString();
                if (((Integer)times.elementAt(i+1)).compareTo(t+1)==0)
                    stimes=stimes+"-";
                else
                    stimes=stimes+" ";
            }else{
                if (((Integer)times.elementAt(i+1)).compareTo(t+1)!=0)
                    stimes=stimes+t.toString()+" ";
            }
        }
        stimes=stimes+times.elementAt(times.size()-1);
        stimes=stimes.substring(1, stimes.length());
        return stimes;
    }

    public static Vector toTimes(String stimes){
        StringTokenizer st=new StringTokenizer(stimes);
        Vector vtimes=new Vector();
        while (st.hasMoreElements()){
            String tmp=st.nextToken();
            int ind=tmp.indexOf('-');
            if (ind==-1){
                vtimes.add(new Integer(tmp));
            }else{
                int beg=Integer.parseInt(tmp.substring(0,ind));
                int end=Integer.parseInt(tmp.substring(ind+1,tmp.length()));
                for (int i=beg; i<=end; i++){
                    vtimes.add(new Integer(i));
                }
            }
        }
        return vtimes;
    }

    public String toString(){
        return (n1.getId()+" "+n2.getId()+" "+this.timesAsString()+"\n");
    }
}
