import java.util.*;
import java.io.*;

public class EvolvingGraphBuilder{
    private String filename;
    public EvolvingGraphBuilder(String filename){
        this.filename=filename;
    }
    public EvolvingGraph getEG(){
        EvolvingGraph EG=new EvolvingGraph();
        try{
            BufferedReader in=new BufferedReader(new FileReader(filename));
            StringTokenizer st;
            String sin="";
            do sin=in.readLine(); while (sin.compareTo("vertices")!=0);
            st = new StringTokenizer(sin," ");
            while ((sin=in.readLine()).compareTo("")!=0){
                st = new StringTokenizer(sin," ");
                String id=st.nextToken();
                EG.addNode(new Node(id));
            }

            do sin=in.readLine(); while (sin.compareTo("edges")!=0);
            while ((sin=in.readLine()).compareTo("")!=0){
                st = new StringTokenizer(sin," ");
                String times="";
                String n1=st.nextToken();
                String n2=st.nextToken();
                
                // Rebuilds the time label
                if (st.hasMoreTokens())
                    times=st.nextToken();
                while (st.hasMoreTokens())
                    times=times+" "+st.nextToken();
                
                EG.addEdge(new Edge(EG.getNodeById(n1),
                                    EG.getNodeById(n2),
                                    Edge.toTimes(times)));
            }
        }catch(Exception e){
            System.out.println("Erreur de construction depuis le fichier");
            e.printStackTrace();
        }
        return EG;
    }
}

